HDU 2489 Minimal Ratio Tree(prim+DFS)

Minimal Ratio Tree

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 3345    Accepted Submission(s): 1019

Problem Description

For a tree, which nodes and edges are all weighted, the ratio of it is calculated according to the following equation.

Given a complete graph of n nodes with all nodes and edges weighted, your task is to find a tree, which is a sub-graph of the original graph, with m nodes and whose ratio is the smallest among all the trees of m nodes in the graph.

Input

Input contains multiple test cases. The first line of each test case contains two integers n (2<=n<=15) and m (2<=m<=n), which stands for the number of nodes in the graph and the number of nodes in the minimal ratio tree. Two zeros end the input. The next line
contains n numbers which stand for the weight of each node. The following n lines contain a diagonally symmetrical n×n connectivity matrix with each element shows the weight of the edge connecting one node with another. Of course, the diagonal will be all
0, since there is no edge connecting a node with itself.

All the weights of both nodes and edges (except for the ones on the diagonal of the matrix) are integers and in the range of [1, 100].

The figure below illustrates the first test case in sample input. Node 1 and Node 3 form the minimal ratio tree.

Output

For each test case output one line contains a sequence of the m nodes which constructs the minimal ratio tree. Nodes should be arranged in ascending order. If there are several such sequences, pick the one which has the smallest node number; if there‘s a tie,
look at the second smallest node number, etc. Please note that the nodes are numbered from 1 .

Sample Input

3 2
30 20 10
0 6 2
6 0 3
2 3 0
2 2
1 1
0 2
2 0
0 0

Sample Output

1 3
1 2

题意描写叙述:

给出n个点的权值和这n个点之间的边的权值。从这n个点之中选出m个点使得这m个点的权值最大,这m个点的生成树中边的权值最小。即Ratio最小。依照升序输出这m个点。

解题思路:

首先n的范围是[2,15],所以能够用dfs搜索使得Ratio最小的点。那么思路基本清晰:首先dfs,搜索全部的点选与不选所得到的最大的Ratio。假设当前状态下得到的Ratio比之前得到的Ratio要小,那么把当前状态的vis数组更新的答案ans数组中。

最后从1到n扫描ans数组就可以保证答案是升序。

參考代码:

#include<stack>
#include<queue>
#include<cmath>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#pragma commment(linker,"/STACK: 102400000 102400000")
using namespace std;
const double eps=1e-6;
const int INF=0x3f3f3f3f;
const int MAXN=20;

int n,m,mincost[MAXN],node[MAXN],edge[MAXN][MAXN];
bool vis[MAXN],used[MAXN],ans[MAXN];
double temp;

double prim()
{
    memset(mincost,0,sizeof(mincost));
    memset(used,false,sizeof(used));
    int s;
    for(int i=1; i<=n; i++)
        if(vis[i])
        {
            s=i;
            break;
        }
    for(int i=1; i<=n; i++)
    {
        mincost[i]=edge[s][i];
        used[i]=false;
    }
    used[s]=true;
    int res=0;
    int nodevalue=node[s];
    for(int j=1; j<n; j++)
    {
        int v=-1;
        for(int i=1; i<=n; i++)
            if(vis[i]&&!used[i]&&(v==-1||mincost[v]>mincost[i]))//vis[i]表示第i个点有没有被选中
                v=i;
        res+=mincost[v];
        nodevalue+=node[v];
        used[v]=true;
        for(int i=1; i<=n; i++)
            if(vis[i]&&!used[i]&&mincost[i]>edge[v][i])
                mincost[i]=edge[v][i];
    }
    return (res+0.0)/nodevalue;
}

void dfs(int pos,int num)
{
    if(num>m)
        return ;
    if(pos==n+1)
    {
        if(num!=m)
            return ;
        double tans=prim();
        if(tans<temp)
        {
            temp=tans;
            memcpy(ans,vis,sizeof(ans));
        }
        return ;
    }
    vis[pos]=true;//选择当前点
    dfs(pos+1,num+1);
    vis[pos]=false;//不选择当前点,消除标记
    dfs(pos+1,num);
}

int main()
{
#ifndef ONLINE_JUDGE
    freopen("in.txt","r",stdin);
#endif // ONLINE_JUDGE
    while(scanf("%d%d",&n,&m))
    {
        if(n==0&&m==0)
            break;
        for(int i=1; i<=n; i++)
            scanf("%d",&node[i]);
        for(int i=1; i<=n; i++)
            for(int j=1; j<=n; j++)
                scanf("%d",&edge[i][j]);
        temp=INF;
        dfs(1,0);
        bool flag=false;
        for(int i=1; i<=n; i++)
        {
            if(ans[i])
            {
                if(flag)
                    printf(" ");
                else
                    flag=true;
                printf("%d",i);
            }
        }
        printf("\n");
    }
    return 0;
}
时间: 2024-08-26 15:44:04

HDU 2489 Minimal Ratio Tree(prim+DFS)的相关文章

HDU 2489 Minimal Ratio Tree(数据结构-最小生成树)

Minimal Ratio Tree Problem Description For a tree, which nodes and edges are all weighted, the ratio of it is calculated according to the following equation. Given a complete graph of n nodes with all nodes and edges weighted, your task is to find a

hdu - 2489 - Minimal Ratio Tree(枚举 + MST)

题意:给出一个图 n x n (2<=n<=15)的图,每个点,每条边都有权值,求其中的 m (2<=m<=n)个点,使得这m个点生成的树的边点权比例最小. 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2489 -->>数量小,于是,可以枚举取 m 个点的所有情况,对每种情况最一次MST,更新最小值.. 时间复杂度:O(n ^ n * log(n) * 2 ^ n) #include <cstdio> #in

HDU 2489 Minimal Ratio Tree(最小生成树)

该题就是最小生成树算法的变形,由于这个比值没有什么规律,不可能一下子算出最小情况,我们可以很容易发现,结点数非常少,所以我们可以枚举出m个结点的所有组合,这样,结点权值只和就确定了,为了使得比值最小,那么就要使得边权值之和最小,也就是最小生成树模板了. 枚举n个数中的m个可以有两种方法: dfs和二进制枚举子集. 该题我用的二进制,感觉比较方便. 细节参见代码: #include<cstdio> #include<cstring> #include<iostream>

hdu 2489 Minimal Ratio Tree(dfs枚举 + 最小生成树)~~~

题目: 链接:点击打开链接 题意: 输入n个点,要求选m个点满足连接m个点的m-1条边权值和sum与点的权值和ans使得sum/ans最小,并输出所选的m个点,如果有多种情况就选第一个点最小的,如果第一个点也相同就选第二个点最小的........ 思路: 求一个图中的一颗子树,使得Sum(edge weight)/Sum(point weight)最小~ 数据量小,暴力枚举~~~~~dfs暴力枚举C(M,N)种情况. 枚举出这M个点之后,Sum(point weight)固定,进行prim或者K

hdu 2489 Minimal Ratio Tree 枚举+最小生成树

点的总数很小,直接枚举就好. #include <stdio.h> #include <string.h> #define N 20 #define inf 1000000 int mk[N],n,k,ans[N]; double low[N],val[N]; double map[N][N],MIN; double prim() { int i,j; double sum=0; double tot=0; for(i=1;i<=n;i++) low[i]=inf; int

HDU 2489 Minimal Ratio Tree (dfs+Prim最小生成树)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2489 Problem Description For a tree, which nodes and edges are all weighted, the ratio of it is calculated according to the following equation. Given a complete graph of n nodes with all nodes and edges

HDU 2489 Minimal Ratio Tree (DFS枚举+最小生成树Prim)

Problem Description For a tree, which nodes and edges are all weighted, the ratio of it is calculated according to the following equation. Given a complete graph of n nodes with all nodes and edges weighted, your task is to find a tree, which is a su

hdu 2489 Minimal Ratio Tree DFS枚举点+最小生成树 属于中等偏上题 ,Double比较大小的时候注意精度问题

Minimal Ratio Tree Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2835    Accepted Submission(s): 841 Problem Description For a tree, which nodes and edges are all weighted, the ratio of it is

HDU 2489 Minimal Ratio Tree

Minimal Ratio Tree Time Limit: 1000ms Memory Limit: 32768KB This problem will be judged on HDU. Original ID: 248964-bit integer IO format: %I64d      Java class name: Maina For a tree, which nodes and edges are all weighted, the ratio of it is calcul